Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 850)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 851)
@@ -4746,130 +5012,161 @@
     	pjsua_media_config_default_doc
     },
-    {
-    	"logging_config_dup", py_pjsua_logging_config_dup, METH_VARARGS,
-    	pjsua_logging_config_dup_doc
-    },
-    {
-    	"config_dup", py_pjsua_config_dup, METH_VARARGS, pjsua_config_dup_doc
-    },
-    {
-    	"pjsip_cred_dup", py_pjsip_cred_dup, METH_VARARGS, pjsip_cred_dup_doc
-    },
+    
+    
     {
     	"msg_data_init", py_pjsua_msg_data_init, METH_VARARGS,
     	pjsua_msg_data_init_doc
     },
-	{
-    	"stun_config_default", py_pjsua_stun_config_default, METH_VARARGS,
-    	pjsua_stun_config_default_doc
-    },
-	{
-    	"transport_config_default", py_pjsua_transport_config_default, 
-			METH_VARARGS,pjsua_transport_config_default_doc
-    },
-	{
-    	"normalize_stun_config", py_pjsua_normalize_stun_config, METH_VARARGS,
-    	pjsua_normalize_stun_config_doc
-    },
-	{
-    	"transport_config_dup", py_pjsua_transport_config_dup, METH_VARARGS,
-    	pjsua_transport_config_dup_doc
-    },
-	{
-    	"transport_create", py_pjsua_transport_create, METH_VARARGS,
-    	pjsua_transport_create_doc
-    },
-	{
-    	"transport_register", py_pjsua_transport_register, METH_VARARGS,
-    	pjsua_transport_register_doc
-    },
-	{
-    	"transport_enum_transports", py_pjsua_enum_transports, METH_VARARGS,
-    	pjsua_enum_transports_doc
-    },
-	{
-    	"transport_get_info", py_pjsua_transport_get_info, METH_VARARGS,
-    	pjsua_transport_get_info_doc
-    },
-	{
-    	"transport_set_enable", py_pjsua_transport_set_enable, METH_VARARGS,
-    	pjsua_transport_set_enable_doc
-    },
-	{
-    	"transport_close", py_pjsua_transport_close, METH_VARARGS,
-    	pjsua_transport_close_doc
-    },
-	{
-    	"acc_config_default", py_pjsua_acc_config_default, METH_VARARGS,
-    	pjsua_acc_config_default_doc
-    },
-	{
-    	"acc_get_count", py_pjsua_acc_get_count, METH_VARARGS,
-    	pjsua_acc_get_count_doc
-    },
-	{
-    	"acc_is_valid", py_pjsua_acc_is_valid, METH_VARARGS,
-    	pjsua_acc_is_valid_doc
-    },
-	{
-    	"acc_set_default", py_pjsua_acc_set_default, METH_VARARGS,
-    	pjsua_acc_set_default_doc
-    },
-	{
-    	"acc_get_default", py_pjsua_acc_get_default, METH_VARARGS,
-    	pjsua_acc_get_default_doc
-    },
-	{
-    	"acc_add", py_pjsua_acc_add, METH_VARARGS,
-    	pjsua_acc_add_doc
-    },
-	{
-    	"acc_add_local", py_pjsua_acc_add_local, METH_VARARGS,
-    	pjsua_acc_add_local_doc
-    },
-	{
-    	"acc_del", py_pjsua_acc_del, METH_VARARGS,
-    	pjsua_acc_del_doc
-    },
-	{
-    	"acc_modify", py_pjsua_acc_modify, METH_VARARGS,
-    	pjsua_acc_modify_doc
-    },
-	{
-    	"acc_set_online_status", py_pjsua_acc_set_online_status, METH_VARARGS,
-    	pjsua_acc_set_online_status_doc
-    },
-	{
-    	"acc_set_registration", py_pjsua_acc_set_registration, METH_VARARGS,
-    	pjsua_acc_set_registration_doc
-    },
-	{
-    	"acc_get_info", py_pjsua_acc_get_info, METH_VARARGS,
-    	pjsua_acc_get_info_doc
-    },
-	{
-    	"enum_accs", py_pjsua_enum_accs, METH_VARARGS,
-    	pjsua_enum_accs_doc
-    },
-	{
-    	"acc_enum_info", py_pjsua_acc_enum_info, METH_VARARGS,
-    	pjsua_acc_enum_info_doc
-    },
-	{
-    	"acc_find_for_outgoing", py_pjsua_acc_find_for_outgoing, METH_VARARGS,
-    	pjsua_acc_find_for_outgoing_doc
-    },
-	{
-    	"acc_find_for_incoming", py_pjsua_acc_find_for_incoming, METH_VARARGS,
-    	pjsua_acc_find_for_incoming_doc
-    },
-	{
-    	"acc_create_uac_contact", py_pjsua_acc_create_uac_contact, METH_VARARGS,
-    	pjsua_acc_create_uac_contact_doc
-    },
-	{
-    	"acc_create_uas_contact", py_pjsua_acc_create_uas_contact, METH_VARARGS,
-    	pjsua_acc_create_uas_contact_doc
-    },
+    {
+        "stun_config_default", py_pjsua_stun_config_default, METH_VARARGS,
+        pjsua_stun_config_default_doc
+    },
+    {
+        "transport_config_default", py_pjsua_transport_config_default, 
+        METH_VARARGS,pjsua_transport_config_default_doc
+    },
+    {
+        "normalize_stun_config", py_pjsua_normalize_stun_config, METH_VARARGS,
+        pjsua_normalize_stun_config_doc
+    },
+    
+    {
+        "transport_create", py_pjsua_transport_create, METH_VARARGS,
+        pjsua_transport_create_doc
+    },
+    {
+        "transport_register", py_pjsua_transport_register, METH_VARARGS,
+        pjsua_transport_register_doc
+    },
+    {
+        "transport_enum_transports", py_pjsua_enum_transports, METH_VARARGS,
+        pjsua_enum_transports_doc
+    },
+    {
+        "transport_get_info", py_pjsua_transport_get_info, METH_VARARGS,
+        pjsua_transport_get_info_doc
+    },
+    {
+        "transport_set_enable", py_pjsua_transport_set_enable, METH_VARARGS,
+        pjsua_transport_set_enable_doc
+    },
+    {
+       "transport_close", py_pjsua_transport_close, METH_VARARGS,
+        pjsua_transport_close_doc
+    },
+    {
+        "acc_config_default", py_pjsua_acc_config_default, METH_VARARGS,
+        pjsua_acc_config_default_doc
+    },
+    {
+        "acc_get_count", py_pjsua_acc_get_count, METH_VARARGS,
+        pjsua_acc_get_count_doc
+    },
+    {
+        "acc_is_valid", py_pjsua_acc_is_valid, METH_VARARGS,
+        pjsua_acc_is_valid_doc
+    },
+    {
+        "acc_set_default", py_pjsua_acc_set_default, METH_VARARGS,
+        pjsua_acc_set_default_doc
+    },
+    {
+        "acc_get_default", py_pjsua_acc_get_default, METH_VARARGS,
+        pjsua_acc_get_default_doc
+    },
+    {
+        "acc_add", py_pjsua_acc_add, METH_VARARGS,
+        pjsua_acc_add_doc
+    },
+    {
+        "acc_add_local", py_pjsua_acc_add_local, METH_VARARGS,
+        pjsua_acc_add_local_doc
+    },
+    {
+        "acc_del", py_pjsua_acc_del, METH_VARARGS,
+        pjsua_acc_del_doc
+    },
+    {
+        "acc_modify", py_pjsua_acc_modify, METH_VARARGS,
+        pjsua_acc_modify_doc
+    },
+    {
+        "acc_set_online_status", py_pjsua_acc_set_online_status, METH_VARARGS,
+        pjsua_acc_set_online_status_doc
+    },
+    {
+        "acc_set_registration", py_pjsua_acc_set_registration, METH_VARARGS,
+        pjsua_acc_set_registration_doc
+    },
+    {
+        "acc_get_info", py_pjsua_acc_get_info, METH_VARARGS,
+        pjsua_acc_get_info_doc
+    },
+    {
+        "enum_accs", py_pjsua_enum_accs, METH_VARARGS,
+        pjsua_enum_accs_doc
+    },
+    {
+        "acc_enum_info", py_pjsua_acc_enum_info, METH_VARARGS,
+        pjsua_acc_enum_info_doc
+    },
+    {
+        "acc_find_for_outgoing", py_pjsua_acc_find_for_outgoing, METH_VARARGS,
+        pjsua_acc_find_for_outgoing_doc
+    },
+    {
+        "acc_find_for_incoming", py_pjsua_acc_find_for_incoming, METH_VARARGS,
+        pjsua_acc_find_for_incoming_doc
+    },
+    {
+        "acc_create_uac_contact", py_pjsua_acc_create_uac_contact, METH_VARARGS,
+        pjsua_acc_create_uac_contact_doc
+    },
+    {
+        "acc_create_uas_contact", py_pjsua_acc_create_uas_contact, METH_VARARGS,
+        pjsua_acc_create_uas_contact_doc
+    },
+    {
+        "get_buddy_count", py_pjsua_get_buddy_count, METH_VARARGS,
+        pjsua_get_buddy_count_doc
+    },
+    {
+        "buddy_is_valid", py_pjsua_buddy_is_valid, METH_VARARGS,
+        pjsua_buddy_is_valid_doc
+    },
+    {
+        "enum_buddies", py_pjsua_enum_buddies, METH_VARARGS,
+        pjsua_enum_buddies_doc
+    },
+    {
+        "buddy_get_info", py_pjsua_buddy_get_info, METH_VARARGS,
+        pjsua_buddy_get_info_doc
+    },
+    {
+        "buddy_add", py_pjsua_buddy_add, METH_VARARGS,
+        pjsua_buddy_add_doc
+    },
+    {
+        "buddy_del", py_pjsua_buddy_del, METH_VARARGS,
+        pjsua_buddy_del_doc
+    },
+    {
+        "buddy_subscribe_pres", py_pjsua_buddy_subscribe_pres, METH_VARARGS,
+        pjsua_buddy_subscribe_pres_doc
+    },
+    {
+        "pres_dump", py_pjsua_pres_dump, METH_VARARGS,
+        pjsua_pres_dump_doc
+    },
+    {
+        "im_send", py_pjsua_im_send, METH_VARARGS,
+        pjsua_im_send_doc
+    },
+    {
+        "im_typing", py_pjsua_im_typing, METH_VARARGS,
+        pjsua_im_typing_doc
+    },
+    
+    
     {NULL, NULL} /* end of function list */
 };
@@ -4885,4 +5182,5 @@
     PyObject* m = NULL;
 
+    
     if (PyType_Ready(&callback_Type) < 0)
         return;
@@ -4918,39 +5216,44 @@
         return;
 
-	/* LIB TRANSPORT */
-
-	if (PyType_Ready(&stun_config_Type) < 0)
+    /* LIB TRANSPORT */
+
+    if (PyType_Ready(&stun_config_Type) < 0)
         return;
-	if (PyType_Ready(&transport_config_Type) < 0)
+    if (PyType_Ready(&transport_config_Type) < 0)
         return;
-	if (PyType_Ready(&sockaddr_Type) < 0)
+    if (PyType_Ready(&sockaddr_Type) < 0)
         return;
-	if (PyType_Ready(&host_port_Type) < 0)
+    if (PyType_Ready(&host_port_Type) < 0)
         return;
-	transport_id_Type.tp_new = PyType_GenericNew;
-	if (PyType_Ready(&transport_id_Type) < 0)
+    
+    if (PyType_Ready(&transport_info_Type) < 0)
         return;
-	if (PyType_Ready(&transport_info_Type) < 0)
-        return;
-	integer_Type.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&integer_Type) < 0)
-        return;
-	pjsip_transport_Type.tp_new = PyType_GenericNew;
+    
+    pjsip_transport_Type.tp_new = PyType_GenericNew;
     if (PyType_Ready(&pjsip_transport_Type) < 0)
         return;
 
-	/* END OF LIB TRANSPORT */
-
-	/* LIB ACCOUNT */
-
-	acc_id_Type.tp_new = PyType_GenericNew;
-	if (PyType_Ready(&acc_id_Type) < 0)
+    /* END OF LIB TRANSPORT */
+
+    /* LIB ACCOUNT */
+
+    
+    if (PyType_Ready(&acc_config_Type) < 0)
         return;
-	if (PyType_Ready(&acc_config_Type) < 0)
+    if (PyType_Ready(&acc_info_Type) < 0)
         return;
-	if (PyType_Ready(&acc_info_Type) < 0)
+
+    /* END OF LIB ACCOUNT */
+
+    /* LIB BUDDY */
+
+    if (PyType_Ready(&buddy_config_Type) < 0)
         return;
-
-	/* END OF LIB ACCOUNT */
+    if (PyType_Ready(&buddy_info_Type) < 0)
+        return;
+
+    /* END OF LIB BUDDY */
+
+    
 
     m = Py_InitModule3(
@@ -4998,36 +5301,44 @@
     );
 
-	/* LIB TRANSPORT */
-
-	Py_INCREF(&stun_config_Type);
+    /* LIB TRANSPORT */
+
+    Py_INCREF(&stun_config_Type);
     PyModule_AddObject(m, "STUN_Config", (PyObject *)&stun_config_Type);
-	Py_INCREF(&transport_config_Type);
+    Py_INCREF(&transport_config_Type);
     PyModule_AddObject
-		(m, "Transport_Config", (PyObject *)&transport_config_Type);
-	Py_INCREF(&sockaddr_Type);
+        (m, "Transport_Config", (PyObject *)&transport_config_Type);
+    Py_INCREF(&sockaddr_Type);
     PyModule_AddObject(m, "Sockaddr", (PyObject *)&sockaddr_Type);
-	Py_INCREF(&host_port_Type);
+    Py_INCREF(&host_port_Type);
     PyModule_AddObject(m, "Host_Port", (PyObject *)&host_port_Type);
-	Py_INCREF(&transport_id_Type);
-    PyModule_AddObject(m, "Transport_ID", (PyObject *)&transport_id_Type);
-	Py_INCREF(&transport_info_Type);
+    
+    Py_INCREF(&transport_info_Type);
     PyModule_AddObject(m, "Transport_Info", (PyObject *)&transport_info_Type);
-	Py_INCREF(&integer_Type);
-    PyModule_AddObject(m, "Integer", (PyObject *)&integer_Type);
-	Py_INCREF(&pjsip_transport_Type);
+    
+    Py_INCREF(&pjsip_transport_Type);
     PyModule_AddObject(m, "PJSIP_Transport", (PyObject *)&pjsip_transport_Type);
 
-	/* END OF LIB TRANSPORT */
-
-	/* LIB ACCOUNT */
-
-	Py_INCREF(&acc_id_Type);
-    PyModule_AddObject(m, "Acc_ID", (PyObject *)&acc_id_Type);
-	Py_INCREF(&acc_config_Type);
+    /* END OF LIB TRANSPORT */
+
+    /* LIB ACCOUNT */
+
+    
+    Py_INCREF(&acc_config_Type);
     PyModule_AddObject(m, "Acc_Config", (PyObject *)&acc_config_Type);
-	Py_INCREF(&acc_info_Type);
+    Py_INCREF(&acc_info_Type);
     PyModule_AddObject(m, "Acc_Info", (PyObject *)&acc_info_Type);
 
-	/* END OF LIB ACCOUNT */
+    /* END OF LIB ACCOUNT */
+
+    /* LIB BUDDY */
+    
+    Py_INCREF(&buddy_config_Type);
+    PyModule_AddObject(m, "Buddy_Config", (PyObject *)&buddy_config_Type);
+    Py_INCREF(&buddy_info_Type);
+    PyModule_AddObject(m, "Buddy_Info", (PyObject *)&buddy_info_Type);
+
+    /* END OF LIB BUDDY */
+
+    
 
 #ifdef PJSUA_INVALID_ID
@@ -5083,3 +5394,15 @@
 #endif
 
-}
+#ifdef PJSUA_MAX_BUDDIES
+    /*
+     * Default account priority.
+     */
+    PyModule_AddIntConstant(
+        m, "PJSUA_MAX_BUDDIES", PJSUA_MAX_BUDDIES
+    );
+#endif
+
+
+
+
+}
